#ifndef DOAGLOBALS_H_
#define DOAGLOBALS_H_

/*
 * DOAGlobals.h
 * Defines global constants used by the DOA overlay
 * 
 * @author levpopov, djwendel, evhan55
 */

#define EID_SIZE 20
#define DOA_PORT 6829 // All DOA packets go on this port
#define DOA_DNS_PORT 21567 // Hardcoded into the stub DNS
#define DOA_DNS_DHT_IP "18.96.2.94" // Use IP location of DNS/DHT servers (assuming same location for both)
#define DOA_DHT_PORT 21568  // Harcoded into the stub DHT
#define DOA_VERSION 2
#define DOA_PROTOCOL 6829 % 256

typedef struct {
   unsigned char bytes[EID_SIZE]; 
} eid;

/* comparator for EIDs */
struct cmpEID{
  bool operator()(eid* s1, eid* s2) const
  {
    return memcmp(s1, s2,sizeof(eid))<0;
  }
};


#endif /*DOAGLOBALS_H_*/
