#ifndef DOAOCD_H_
#define DOAOCD_H_

/*
 * DOAOCD.h
 * Defines DOAOCD class which is the main class implementing the OCALA OCD interface.
 * 
 * @author levpopov, djwendel, evhan55
 * Code adapted from SampleOCD.h
 */
#include "OCD_include.h"

class DOAStateInfo;
class OCI;
class DOAContext;

class DOAOCD: public OCD
{
  
public:

    /** All the OC-D specific processing is done by this context object. */
    DOAContext* context;

    DOAOCD (string type, string id, 
                    string desc, string fileName, 
                    string urlSuffixes, bool handleLegacyURLs
                );
    DOAOCD (OCD *);

    virtual void init(Proxy*, OCI*, bool recoverFromCrash );

    char* toString(char *tmpStr);
    void initMyNames ();


    void send ( LayerHandle handle, char* data, int dataLen);
    LayerHandle setup (
                const string endPointName, 
                int endPointNameType,
                char *optionBlocks, 
                int optionLen,
                LayerHandle ociHandle,
                OCI* oci );
                
    friend class DOAContext;
    friend class DOAStateInfo;
};

#endif /*DOAOCD_H_*/

