#ifndef ERECORD_H_
#define ERECORD_H_

#include <vector>
#include "DOAGlobals.h"

/*
 * ERecord.h
 * Defines ERecord class, which represents DOA hostname information stored in DOA DHT.
 * NOTE: NOT USED IN CURRENT IMPLEMENTATION
 * TODO make this usable and then use it, rather than directly manipulating DHT incoming packets
 * 
 * @author levpopov, djwendel, evhan55
 */

using namespace std;
 
class ERecord
{
public:
	/* eid field */
	eid EID;
	/* target field - only one of the vectors is nonempty */
	vector<eid*> targetEIDs;
	vector<uint32_t> targetIPs;
	bool targetIsIP;
	/* hint field */
	char* hint;
	int hintLen;
	/* TTL field */
	int TTL; //TODO enforce this in the code
	
	friend class DOAContext;

};

#endif /*ERECORD_H_*/
