##############################
# Dummy DOA DHT Implementation
# author evhan55
##############################

#################
# ERecord fields:
#################
# eid EID
# vector<eid*> targetEIDs
# vector<uint32_t> targetIPs
# bool targetIsIP
# char* hint;
# int hintLen
# int TTL
#################

#Server program

from socket import *

#Set the socket parameters
host = "18.96.2.94"
port = 21568
buf = 1024
addr = (host,port)

#Create socket and bind to address
UDPSock = socket(AF_INET,SOCK_DGRAM)
UDPSock.bind(addr)

#Create EID -> ERecord dictionary
mappings = {}

#Receive messages
while 1:
	data,addr = UDPSock.recvfrom(buf)
	addr = (addr[0],6829)	#HARD CODED PORT
	if not data:
		print "Client has exited!"
		break
	else:
		print "\nReceived DOADHT_Request '", data, "'"
		
		##################################
		# If request is a REGISTER request
		##################################
		if(len(data) > 24):
			
			print "\nReceived DOADHT_Register_Request"

			##########
			# REGISTER
			##########
			erecord = data
			EID = data[0:20]
			mappings[EID] = erecord
			print "\nRegistered (",EID,",",erecord,")","pair."
			
			##########
			# SEND ACK
			##########
			ack = "DOADHT_ACK"
			print "Sending ACK to address: ",addr
			if(UDPSock.sendto(ack,addr)):
				print "\nDOADHT_ACK sent..."
			else:
				print "\nDOADHT_ACK not sent for some reason..."

		#################################
		# If request is a RESOLVE request
		#################################
		else:

			print "\nReceived DOADHT_Resolve_Request"

			###############
			# ADDRESS FOUND
			###############
			EID = data[0:20]
			state_info = data[20:len(data)]
			if(mappings.has_key(EID)):
				erecord = mappings[EID]
				print "\nRecord found...",erecord
				
				##############################
				# SEND REPLY: RESOLVED ADDRESS
				##############################
				reply = "dhtSUCCESS"+state_info+erecord		
				if(UDPSock.sendto(reply,addr)):
                                	print "\nDOADHT_REPLY_FOUND sent...",reply
                        	else:
                                	print "\nDOADHT_REPLY_FOUND not sent for some reason..."
	
			###################
			# ADDRESS NOT FOUND
			###################
			else:
				###############################
				# SEND REPLY: ADDRESS NOT FOUND
				###############################
				print "\nRecord not found!"
				reply = "dhtFAILURE"+state_info
				if(UDPSock.sendto(reply,addr)):
                                        print "\nDOADHT_REPLY_NOT_FOUND sent..."
                                else:
                                        print "\nDOADHT_REPLY_NOT_FOUND not sent for some reason..."
				

		print "\nEntire DHT Registry:", mappings
		print "\n%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"

#Close socket
UDPSock.close()
