##############################
# Dummy DOA DNS Implementation
# @author evhan55
##############################

###################
# DNS PACKET FORMAT
###################
#
# REGISTER: (0somerandomaddressEIDEIDEIDEIDEIDEIDEI)
#
# RESOLVE: (dnsCCCCsomerandomaddress) 
#
# REPLY_FOUND: (dnsCCCCEIDEIDEIDEIDEIDEIDEI)
#
###################

#Server program

from socket import *

#Set the socket parameters
host = "18.96.2.94"
port = 21567
buf = 1024
addr = (host,port)

#Create socket and bind to address
UDPSock = socket(AF_INET,SOCK_DGRAM)
UDPSock.bind(addr)

#Create DOAAdress -> EID dictionary
mappings = {}

#Receive messages
while 1:
	print "--------------------------------"
	data,addr = UDPSock.recvfrom(buf)
	addr = (addr[0],6829)	#HARD CODED PORT
	if not data:
		print "Client has exited!"
		break
	else:
		print "\nReceived DOADNS_Request '",data, "'"
		
		##################################
		# If request is a REGISTER request
		##################################
		if(data[0] == "0"):

			print "\nReceived DOADNS_Register_Request"

			##########
			# REGISTER
			##########
			address = data[1:len(data)-20]
			EID = data[len(data)-20:len(data)]
			mappings[address] = EID
			print "\nRegistered (",address,",",EID,")","pair."
			
			##########
			# SEND ACK
			##########
			ack = "DOADNS_ACK"
			print "Sending ACK to address: ",addr
			if(UDPSock.sendto(ack,addr)):
				print "\nDOADNS_ACK sent..."
			else:
				print "\nDOADNS_ACK not sent for some reason..."

		#################################
		# If request is a RESOLVE request
		#################################
		else:
			print "\nReceived DOADNS_Resolve_Request.."
			address_to_resolve = data[7:len(data)]
			print "\nAddress to resolve:",address_to_resolve
                        state_pointer = data[3:7]
			print "\nState_pointer: ",ord(state_pointer[0]),".",ord(state_pointer[1]),".",ord(state_pointer[2]),".",ord(state_pointer[3])

			###############
			# ADDRESS FOUND
			###############
			if(mappings.has_key(address_to_resolve)):
				EID = mappings[address_to_resolve]
				print "\nRecord found...",EID
				
				##############################
				# SEND REPLY: RESOLVED ADDRESS
				##############################
				reply = "dns"+state_pointer+EID		
				if(UDPSock.sendto(reply,addr)):
                                	print "\nDOADNS_REPLY_FOUND sent..."
                        	else:
                                	print "\nDOADNS_REPLY_FOUND not sent for some reason..."
	
			###################
			# ADDRESS NOT FOUND
			###################
			else:	
				###############################
				# SEND REPLY: ADDRESS NOT FOUND
				###############################
				print "\nRecord not found!"
				reply = "dns"+state_pointer+"DNSADDRESS_NOT_FOUND"
				if(UDPSock.sendto(reply,addr)):
                                        print "\nDOADNS_REPLY_NOT_FOUND sent..."
                                else:
                                        print "\nDOADNS_REPLY_NOT_FOUND not sent for some reason..."
				

		print "\nEntire Registry:", mappings
		print "--------------------------------"		

#Close socket
UDPSock.close()
